#include "otaEvent.h"
#include "usart.h"
#include "systick.h"
#include "w25q32.h"

#define APPBLOCKNB 2      	//下载的程序位于block的第3块中
#define OTA_EVENT_BLOCKNB 1 //OTA事件完成标志存储的位置位于第2块中

#define SOH 0x01 // XMOD协议帧头
#define ACK 0X06 // 应答标志
#define NAK 0x15 // 非应答标志
#define EOT 0x04 // 结束标志
int8_t xmodem(uint16_t timeout);
OTA_T ota_data;
uint8_t w25q32_data[256];  //存放w25q32数据

uint16_t Xmodem_CRC16(uint8_t *data, uint16_t datalen);
/*
 *  函数名：uint8_t check_ota_event()
 *  输入参数：无
 *  输出参数：无
 *  返回值：无
 *  函数作用：判断ota事件是否产生是否要进入更新部分
 */
int8_t check_ota_event()
{
	// 当标志位为1时证明ota事件产生,将进入ota升级路线
	if (ota_data.ota_flag == 1)
	{
		W25Q32_Erase64K(APPBLOCKNB);                    //程序文件在第三block以后
		int8_t recvSta = xmodem(1000);
		if (recvSta == 0)
		{
			return 0;
		}
		else  
		{
			NVIC_SystemReset();
		}
	}
	else
		return 0;
}

int8_t xmodem(uint16_t timeout)
{
	int startTime = gettick();
	ota_data.done=0;
	OTA_flag data_flag;
	data_flag.flag=0;
	data_flag.xmodemNB=0;                         
	while(1)
	{
		if(gettick()-startTime>timeout*1000)return 0;
		usart_data_transmit(COM_232, 'C');
		delay_1ms(1000);
		if(ota_data.done==1)break;
	}
	// 判断数据帧头是否符合标准
	while (gettick() - startTime < timeout * 1000)
	{
		if (ota_data.done == 1)
		{
			if (ota_data.data[0] == SOH && ota_data.data_cnt == 133)
			{
				uint16_t XCRC = Xmodem_CRC16(ota_data.data + 3, 128);
				if (XCRC == ota_data.data[131] * 256 + ota_data.data[132]) // 经过校验的数据一致时将进行数据处理
				{
					data_flag.xmodemNB++;
					//因为W25Q32只支持按页写入数据、所以将128字节数据找了一个暂存空间，两次应答才进行一次数据写入，最后在结束语句判断是否为奇数在进行
					//数据尾部的处理
					if(ota_data.data[1]%2==0)                                      
					{
						memcpy(w25q32_data+128,ota_data.data + 3,128);
						W25Q32_PageWrite(w25q32_data,APPBLOCKNB*256+(data_flag.xmodemNB-1)/2);
						memset(w25q32_data,0,256);
					}
					else
					{
						memcpy(w25q32_data,ota_data.data + 3,128);
					}
					
					ota_data.data_cnt = 0;
					memset(ota_data.data, 0, 133);
					ota_data.done = 0;
					usart_data_transmit(COM_232, ACK);
	
				}
				else
				{
					ota_data.data_cnt = 0;
					memset(ota_data.data, 0, 133);
					ota_data.done = 0;
					usart_data_transmit(COM_232, NAK);
				}
			}
			//进入结束的包处理
			else if (ota_data.data[0] == EOT && ota_data.data_cnt == 1)
			{
				if(data_flag.xmodemNB%2!=0)                                            //将可能为奇数的数据写入进去
				{
					W25Q32_PageWrite(w25q32_data,APPBLOCKNB*256+(data_flag.xmodemNB-1)/2);
				}
				
				
				
				usart_data_transmit(COM_232, ACK);
				//完成xmodem协议的交互将完成的标志存储到内存中
				OTA_MESSAGE ota_message;
				ota_message.Completion_flag=1U;
				ota_message.XmodemByte=data_flag.xmodemNB*128;//后续补齐的0x1A还需要进一步考虑

				W25Q32_Erase64K(OTA_EVENT_BLOCKNB);//擦除原先的数据
				W25Q32_PageWrite((uint8_t *)&ota_message,OTA_EVENT_BLOCKNB*256);
			
				delay_1ms(50);
				// 写入事件完成标志后重启设备,其他状态页无需回滚，写入完成会执行重启指令
				return 1;
			}
			else
			{
				ota_data.data_cnt = 0;
				memset(ota_data.data, 0, 133);
				ota_data.done = 0;
				usart_data_transmit(COM_232, NAK);
			}
		}

		delay_1ms(1);
	}
	return 0;
}

/*-------------------------------------------------*/
/*函数名：Xmodem_CRC16校验                         */
/*参  数：data：数据指针  datalen：数据长度        */
/*返回值：校验后的数据                             */
/*-------------------------------------------------*/
uint16_t Xmodem_CRC16(uint8_t *data, uint16_t datalen)
{

	uint8_t i;					// 用于for循环
	uint16_t Crcinit = 0x0000;	// Xmdoem CRC校验的初始值，必须是0x0000
	uint16_t Crcipoly = 0x1021; // Xmdoem CRC校验的多项式，必须是0x1021

	while (datalen--)
	{									  // 根据datalen大小，有多少字节循环多少次
		Crcinit = (*data << 8) ^ Crcinit; // 先将带校验的字节，挪到高8位
		for (i = 0; i < 8; i++)
		{											 // 每个字节8个二进制位，循环8次
			if (Crcinit & 0x8000)					 // 判断BIT15是1还是0,是1的话，进入if
				Crcinit = (Crcinit << 1) ^ Crcipoly; // 是1的话，先左移，再异或多项式
			else									 // 判断BIT15是1还是0,是0的话，进入else
				Crcinit = (Crcinit << 1);			 // 是0的话，只左移
		}
		data++; // 下移，计算一个字节数据
	}
	return Crcinit; // 返回校验后的数据
}
